searchNodes=[{"doc":"Archeometer Archeometer is a code analysis tool to help diagnose potential problems and refactoring points, particularly in large code bases. It does this by collecting as much information about the code as possible and storing it in a SQLite database for later processing. For now, some parts are implemented as a Credo Plugin, though this will change in the future. Metrics For now there are three types of metric: Static: Information about the code AST Compilation: Project/application classification Testing: Code coverage Cross references: Internal dependencies between modules","ref":"Archeometer.html","title":"Archeometer","type":"module"},{"doc":"Mix Task to generate a dependency graph for the applications within an umbrella. Usage: mix arch . apps . xref [ options ] The following options are accepted: --format - Can be one of dot , png or svg --out - Output filename","ref":"Mix.Tasks.Arch.Apps.Xref.html","title":"Mix.Tasks.Arch.Apps.Xref","type":"task"},{"doc":"Mix task to gather information about the project and store it into the database. It currently gathers information about: Inventory of applications, modules, functions and macros. Metrics related to them such as: size and complexity. Information about test coverage. Internal dependencies between modules. Usage: mix arch.collect [options] The following options are accepted: --no-coverage avoid running tests and collecting coverage information --include-deps wildcard glob style to filter dependencies","ref":"Mix.Tasks.Arch.Collect.html","title":"Mix.Tasks.Arch.Collect","type":"task"},{"doc":"Mix Task to collect application names, module application id, module implemented behaviours, module defined structs and store them into a Archeometer database. Usage: mix arch . collect . apps [ options ] The following options are accepted: --include-deps - Wildcard glob style to filter dependencies For more information see: Basic usage guide","ref":"Mix.Tasks.Arch.Collect.Apps.html","title":"Mix.Tasks.Arch.Collect.Apps","type":"task"},{"doc":"Mix Task to collect and store test coverage information into a Archeometer database.","ref":"Mix.Tasks.Arch.Collect.Coverage.html","title":"Mix.Tasks.Arch.Collect.Coverage","type":"task"},{"doc":"Mix Task to run Credo and save the issues it found. Usage: mix arch . collect . credo_issues [ options ] The following options are accepted: --include-deps - Wildcard glob style to filter dependencies This option is accepted but currently ignored. For more information see: Basic usage guide","ref":"Mix.Tasks.Arch.Collect.CredoIssues.html","title":"Mix.Tasks.Arch.Collect.CredoIssues","type":"task"},{"doc":"Mix Task to collect information of Ecto schema modules and their relationships. Usage: mix arch . collect . ecto [ options ] The following options are accepted: --include-deps - Wildcard glob style to filter dependencies For more information see: Basic usage guide","ref":"Mix.Tasks.Arch.Collect.Ecto.html","title":"Mix.Tasks.Arch.Collect.Ecto","type":"task"},{"doc":"Mix Task to run code AST analysis of modules, functions and macros and store its findings into a Archeometer database. Usage: mix arch . collect . static [ options ] The following options are accepted: --include-deps - Wildcard glob style to filter dependencies For more information see: Basic usage guide","ref":"Mix.Tasks.Arch.Collect.Static.html","title":"Mix.Tasks.Arch.Collect.Static","type":"task"},{"doc":"Mix Task to analyze internal dependencies between modules and store them into a Archeometer database. Usage: mix arch . collect . xrefs [ options ] The following options are accepted: --include-deps - Wildcard glob style to filter dependencies For more information see: Basic usage guide","ref":"Mix.Tasks.Arch.Collect.Xrefs.html","title":"Mix.Tasks.Arch.Collect.Xrefs","type":"task"},{"doc":"Mix Task to perform a Design Structure Matrix (DSM) analysis. Usage: mix arch . dsm [ options ] The following options are accepted: --app - Application name --ns - Namespace of the modules considered --db - Database filename --format - Can be one of txt (default) or svg --out - Output filename. Defaults to console --skip-tests - Skips test related modules (default) --no-skip-tests - Avoids skipping test related modules Both options --app or --ns can be used at the same time in order to have fine grained control of the set of modules considered in the analysis. If none of --app or --ns options are given, all modules in the project are considered. Namespace is interpreted very broadly since Elixir doesn't have that concept. Namespace can be interpreted as a string matching the beginning of the module names to be considered, such as &quot;Foo&quot; or &quot;Foo.Bar&quot;, after which a last part of the name must be given to create a full module name. For example the &quot;namespace&quot; Foo will include in the analysis modules such as Foo.Bar , Foo.Baz and Foo.Bar.Buzz , but not FooBar or Food .","ref":"Mix.Tasks.Arch.Dsm.html","title":"Mix.Tasks.Arch.Dsm","type":"task"},{"doc":"Mix Task to generate a static HTML report. Usage: mix arch . report . html [ options ] Options: --limit - Restricts the maximum number of results displayed from the queries in the report, Default is 10. --db - Database filename For more information see: Basic usage guide Report is generated at reports/dev/static/html .","ref":"Mix.Tasks.Arch.Report.Html.html","title":"Mix.Tasks.Arch.Report.Html","type":"task"},{"doc":"Mix Task to generate a treemap for an application or a set of modules. Usage: mix arch . treemap [ options ] The following options are accepted: --metric - Temporarily there is just one metric: size (default) --ns - Namespace of the modules considered --app - Application name --db - Database filename --out - Output filename --skip-tests - Skips test related modules (default) --format - Temporarily there is just one format: svg (default)","ref":"Mix.Tasks.Arch.Treemap.html","title":"Mix.Tasks.Arch.Treemap","type":"task"},{"doc":"Mix Task to generate a dependency graph given some module names. Usage: mix arch . xref [ options ] mod1 mod2 .. modN The following options are accepted: --db - Database filename --format - Can be one of dot , png or svg --out - Output filename --app - Application name --ns - Namespace of the modules to consider --origin - Subgraph of modules that are called from the given module --dest - Subgraph of modules that calls a given module","ref":"Mix.Tasks.Arch.Xref.html","title":"Mix.Tasks.Arch.Xref","type":"task"},{"doc":"Module for collecting test coverage statistics, using Erlang cover module. As it's a tool for Erlang code, instead of using its module and function capabilities, the line coverage is directly used, and then counted per module, in the same manner the Mix test.coverage task does.","ref":"Archeometer.Collect.Coverage.html","title":"Archeometer.Collect.Coverage","type":"module"},{"doc":"","ref":"Archeometer.Collect.Coverage.html#calculate_function_coverage/0","title":"Archeometer.Collect.Coverage.calculate_function_coverage/0","type":"function"},{"doc":"","ref":"Archeometer.Collect.Coverage.html#calculate_module_coverage/0","title":"Archeometer.Collect.Coverage.calculate_module_coverage/0","type":"function"},{"doc":"","ref":"Archeometer.Collect.Coverage.html#cover_compile/0","title":"Archeometer.Collect.Coverage.cover_compile/0","type":"function"},{"doc":"","ref":"Archeometer.Collect.Coverage.html#prepare_code_server/0","title":"Archeometer.Collect.Coverage.prepare_code_server/0","type":"function"},{"doc":"Credo Task to collect and save metrics from an static analysis of an Elixir project..","ref":"Archeometer.Collect.Credo.SaveStatsTask.html","title":"Archeometer.Collect.Credo.SaveStatsTask","type":"module"},{"doc":"Module for running Credo into the current project and collect all the issues it found.","ref":"Archeometer.Collect.CredoIssues.html","title":"Archeometer.Collect.CredoIssues","type":"module"},{"doc":"","ref":"Archeometer.Collect.CredoIssues.html#collect/1","title":"Archeometer.Collect.CredoIssues.collect/1","type":"function"},{"doc":"","ref":"Archeometer.Collect.CredoIssues.html#new/1","title":"Archeometer.Collect.CredoIssues.new/1","type":"function"},{"doc":"Module for collecting information about Ecto schemas and their associations between them.","ref":"Archeometer.Collect.Ecto.html","title":"Archeometer.Collect.Ecto","type":"module"},{"doc":"","ref":"Archeometer.Collect.Ecto.html#clear_references/1","title":"Archeometer.Collect.Ecto.clear_references/1","type":"function"},{"doc":"","ref":"Archeometer.Collect.Ecto.html#ecto_schemas/1","title":"Archeometer.Collect.Ecto.ecto_schemas/1","type":"function"},{"doc":"","ref":"Archeometer.Collect.Ecto.html#get_associations/1","title":"Archeometer.Collect.Ecto.get_associations/1","type":"function"},{"doc":"Utilities for obtaining higher level information about a project, mostly through Mix and Application.","ref":"Archeometer.Collect.Project.html","title":"Archeometer.Collect.Project","type":"module"},{"doc":"Obtain the list of local app in the current project. This is the value of :app in regular projects and all the children apps in umbrella projects.","ref":"Archeometer.Collect.Project.html#apps/0","title":"Archeometer.Collect.Project.apps/0","type":"function"},{"doc":"Returns the project dependencies that matches the filters. Parameters filters: List of wildcard style strings to use as filters.","ref":"Archeometer.Collect.Project.html#filter_deps/1","title":"Archeometer.Collect.Project.filter_deps/1","type":"function"},{"doc":"Get the (underscored) module name of the current project mix.exs file. Every directory with one is considered a project by Mix.","ref":"Archeometer.Collect.Project.html#get!/0","title":"Archeometer.Collect.Project.get!/0","type":"function"},{"doc":"","ref":"Archeometer.Collect.Project.html#get_app_deps/1","title":"Archeometer.Collect.Project.get_app_deps/1","type":"function"},{"doc":"","ref":"Archeometer.Collect.Project.html#get_curr_app_deps/1","title":"Archeometer.Collect.Project.get_curr_app_deps/1","type":"function"},{"doc":"","ref":"Archeometer.Collect.Project.html#get_dep_path/1","title":"Archeometer.Collect.Project.get_dep_path/1","type":"function"},{"doc":"Given a file path, try to guess its application. If the project is not umbrella, just return the project app. Else try to parse the path to guess the application.","ref":"Archeometer.Collect.Project.html#guess_app_from_path/1","title":"Archeometer.Collect.Project.guess_app_from_path/1","type":"function"},{"doc":"","ref":"Archeometer.Collect.Project.html#in_app/2","title":"Archeometer.Collect.Project.in_app/2","type":"function"},{"doc":"","ref":"Archeometer.Collect.Project.html#list_behaviours/1","title":"Archeometer.Collect.Project.list_behaviours/1","type":"function"},{"doc":"","ref":"Archeometer.Collect.Project.html#list_modules_with_struct/1","title":"Archeometer.Collect.Project.list_modules_with_struct/1","type":"function"},{"doc":"Get all the locally defined modules.","ref":"Archeometer.Collect.Project.html#local_modules/1","title":"Archeometer.Collect.Project.local_modules/1","type":"function"},{"doc":"Obtain all the locally defined modules by application.","ref":"Archeometer.Collect.Project.html#local_modules_by_app/1","title":"Archeometer.Collect.Project.local_modules_by_app/1","type":"function"},{"doc":"","ref":"Archeometer.Collect.Project.html#tag_external_apps/1","title":"Archeometer.Collect.Project.tag_external_apps/1","type":"function"},{"doc":"","ref":"Archeometer.Collect.Project.html#test_paths/1","title":"Archeometer.Collect.Project.test_paths/1","type":"function"},{"doc":"Obtain all the apps defined as umbrella children.","ref":"Archeometer.Collect.Project.html#umbrella_apps/0","title":"Archeometer.Collect.Project.umbrella_apps/0","type":"function"},{"doc":"Module for analysing AST and collecting some useful information For now the schemas are hardcoded. There are Modules Definitions (functions, macros) Hopefully in the future a more extendible solution will be in place.","ref":"Archeometer.Collect.Static.html","title":"Archeometer.Collect.Static","type":"module"},{"doc":"","ref":"Archeometer.Collect.Static.html#def_stats_for/2","title":"Archeometer.Collect.Static.def_stats_for/2","type":"function"},{"doc":"","ref":"Archeometer.Collect.Static.html#module_stats_for/2","title":"Archeometer.Collect.Static.module_stats_for/2","type":"function"},{"doc":"","ref":"Archeometer.Collect.Static.html#process_def/2","title":"Archeometer.Collect.Static.process_def/2","type":"function"},{"doc":"","ref":"Archeometer.Collect.Static.html#process_module/2","title":"Archeometer.Collect.Static.process_module/2","type":"function"},{"doc":"Module for collecting cross references between modules defined in the same project.","ref":"Archeometer.Collect.XRef.html","title":"Archeometer.Collect.XRef","type":"module"},{"doc":"","ref":"Archeometer.Collect.XRef.html#compile_xrefs/2","title":"Archeometer.Collect.XRef.compile_xrefs/2","type":"function"},{"doc":"","ref":"Archeometer.Collect.XRef.html#save_event/2","title":"Archeometer.Collect.XRef.save_event/2","type":"function"},{"doc":"","ref":"Archeometer.Collect.XRef.html#trace/2","title":"Archeometer.Collect.XRef.trace/2","type":"function"},{"doc":"Provides functions to access the configuration of reports.","ref":"Archeometer.Reports.Config.html","title":"Archeometer.Reports.Config","type":"module"},{"doc":"","ref":"Archeometer.Reports.Config.html#report_path/1","title":"Archeometer.Reports.Config.report_path/1","type":"function"},{"doc":"","ref":"Archeometer.Reports.Config.html#static_report_img_path/0","title":"Archeometer.Reports.Config.static_report_img_path/0","type":"function"},{"doc":"","ref":"Archeometer.Reports.Config.html#static_report_path/0","title":"Archeometer.Reports.Config.static_report_path/0","type":"function"},{"doc":"Represents a fragment, which is part of a section in a page.","ref":"Archeometer.Reports.Fragment.html","title":"Archeometer.Reports.Fragment","type":"module"},{"doc":"","ref":"Archeometer.Reports.Fragment.html#alt_process/3","title":"Archeometer.Reports.Fragment.alt_process/3","type":"function"},{"doc":"","ref":"Archeometer.Reports.Fragment.html#make_custom_env/0","title":"Archeometer.Reports.Fragment.make_custom_env/0","type":"function"},{"doc":"","ref":"Archeometer.Reports.Fragment.html#process/3","title":"Archeometer.Reports.Fragment.process/3","type":"function"},{"doc":"Represents the definition of a Fragment.","ref":"Archeometer.Reports.Fragment.Definition.html","title":"Archeometer.Reports.Fragment.Definition","type":"module"},{"doc":"Generates a report given a configuration and parameters.","ref":"Archeometer.Reports.Generator.html","title":"Archeometer.Reports.Generator","type":"module"},{"doc":"","ref":"Archeometer.Reports.Generator.html#generate/1","title":"Archeometer.Reports.Generator.generate/1","type":"function"},{"doc":"Represents a Page of the report. Each page is associated with an application.","ref":"Archeometer.Reports.Page.html","title":"Archeometer.Reports.Page","type":"module"},{"doc":"","ref":"Archeometer.Reports.Page.html#process/3","title":"Archeometer.Reports.Page.process/3","type":"function"},{"doc":"Represents the definition of a Page.","ref":"Archeometer.Reports.Page.Definition.html","title":"Archeometer.Reports.Page.Definition","type":"module"},{"doc":"Defines the structure of the page definition for a single application.","ref":"Archeometer.Reports.PageDefinition.Application.html","title":"Archeometer.Reports.PageDefinition.Application","type":"module"},{"doc":"","ref":"Archeometer.Reports.PageDefinition.Application.html#definition/1","title":"Archeometer.Reports.PageDefinition.Application.definition/1","type":"function"},{"doc":"Defines the page structure for a project.","ref":"Archeometer.Reports.PageDefinition.Project.html","title":"Archeometer.Reports.PageDefinition.Project","type":"module"},{"doc":"","ref":"Archeometer.Reports.PageDefinition.Project.html#definition/1","title":"Archeometer.Reports.PageDefinition.Project.definition/1","type":"function"},{"doc":"Renders a page into HTML.","ref":"Archeometer.Reports.Render.Html.html","title":"Archeometer.Reports.Render.Html","type":"module"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#button_copy/3","title":"Archeometer.Reports.Render.Html.button_copy/3","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#button_tab/3","title":"Archeometer.Reports.Render.Html.button_tab/3","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#code_fragment/2","title":"Archeometer.Reports.Render.Html.code_fragment/2","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#fragment/2","title":"Archeometer.Reports.Render.Html.fragment/2","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#fragment_result/2","title":"Archeometer.Reports.Render.Html.fragment_result/2","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#header/2","title":"Archeometer.Reports.Render.Html.header/2","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#main_report/2","title":"Archeometer.Reports.Render.Html.main_report/2","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#nav_side_menu/2","title":"Archeometer.Reports.Render.Html.nav_side_menu/2","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#render/3","title":"Archeometer.Reports.Render.Html.render/3","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#result_table/2","title":"Archeometer.Reports.Render.Html.result_table/2","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#sections/2","title":"Archeometer.Reports.Render.Html.sections/2","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#sidemenu_item/2","title":"Archeometer.Reports.Render.Html.sidemenu_item/2","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#svg_container/3","title":"Archeometer.Reports.Render.Html.svg_container/3","type":"function"},{"doc":"","ref":"Archeometer.Reports.Render.Html.html#tab_content/4","title":"Archeometer.Reports.Render.Html.tab_content/4","type":"function"},{"doc":"Represents a Section, which is part of a Page.","ref":"Archeometer.Reports.Section.html","title":"Archeometer.Reports.Section","type":"module"},{"doc":"","ref":"Archeometer.Reports.Section.html#process/3","title":"Archeometer.Reports.Section.process/3","type":"function"},{"doc":"Represents the definition of a Section.","ref":"Archeometer.Reports.Section.Definition.html","title":"Archeometer.Reports.Section.Definition","type":"module"},{"doc":"Utility functions for generating reports","ref":"Archeometer.Reports.Utils.html","title":"Archeometer.Reports.Utils","type":"module"},{"doc":"","ref":"Archeometer.Reports.Utils.html#copy_assets/0","title":"Archeometer.Reports.Utils.copy_assets/0","type":"function"},{"doc":"","ref":"Archeometer.Reports.Utils.html#copy_images/0","title":"Archeometer.Reports.Utils.copy_images/0","type":"function"},{"doc":"","ref":"Archeometer.Reports.Utils.html#prepare_paths/0","title":"Archeometer.Reports.Utils.prepare_paths/0","type":"function"},{"doc":"","ref":"Archeometer.Reports.Utils.html#report_path/1","title":"Archeometer.Reports.Utils.report_path/1","type":"function"},{"doc":"","ref":"Archeometer.Reports.Utils.html#write_to_file/2","title":"Archeometer.Reports.Utils.write_to_file/2","type":"function"},{"doc":"Functions for generating a dependency graph from applications in an Elixir project. Accepted output formats are &quot;dot&quot; (graphviz), &quot;png&quot; and &quot;mermaid&quot;.","ref":"Archeometer.Analysis.Apps.Xref.html","title":"Archeometer.Analysis.Apps.Xref","type":"module"},{"doc":"Creates a dependency graph between the applications of the current project. Parameters 'format' can be one of &quot;dot&quot; (graphviz), &quot;png&quot;, or &quot;mermaid&quot;. 'db' is the database path Returns The binary representing the graph, if the operation was completed successfully. {:error, reason} if not.","ref":"Archeometer.Analysis.Apps.Xref.html#gen_graph/2","title":"Archeometer.Analysis.Apps.Xref.gen_graph/2","type":"function"},{"doc":"Defines algorithms for Design Structure Matrix (DSM) analysis. A DSM represents a graph of dependencies between components or processes, in this case, between Elixir modules. See DSM Web . In this implementation, the DSM is represented by the DSM struct, with the following attributes: nodes . A List of of nodes that besides enumerating the nodes, defines at the same time the order of rows and columns. They have always the same order. edges . The edges of the graph, in the form of a map, with a key representing existing edges within the matrix in the form of {row, col} , and values can be one of :+ or :* . :+ is used when row and col have the same value, and :* is used whenever the module represented by col has a dependency on module represented by row . groups . Its a map of identified cyclic groups within the graph, every key is just an identifier for the gruop, and the value is a list of the nodes conforming that gruop. The value of groups is calculated by the algorithm and not expected to be set by the user. n_groups . This is used for internal use of the algorithms only and not expected to be of any use to final users. Functions gen_dsm/1 and gen_dsm/4 are used to create a DSM respectively from an adjacency list or from information in an Archeometer database. The only analysis algorith currently implemented is called triangularization , and you can use it with the function triangularize/1 . It helps you find groups of nodes that form cycles.","ref":"Archeometer.Analysis.DSM.html","title":"Archeometer.Analysis.DSM","type":"module"},{"doc":"Gets a list of module groups with cyclic dependencies.","ref":"Archeometer.Analysis.DSM.html#cyclic_deps_groups/1","title":"Archeometer.Analysis.DSM.cyclic_deps_groups/1","type":"function"},{"doc":"","ref":"Archeometer.Analysis.DSM.html#find_cycle/1","title":"Archeometer.Analysis.DSM.find_cycle/1","type":"function"},{"doc":"Creates a DSM from an adjacency list Examples iex&gt; adj_list = %{ ...&gt; 1 =&gt; [ 2 , 3 ] , ...&gt; 2 =&gt; [ 3 , 4 ] , ...&gt; 3 =&gt; [ 4 ] , ...&gt; 4 =&gt; [ 3 ] ...&gt; } %{ 1 =&gt; [ 2 , 3 ] , 2 =&gt; [ 3 , 4 ] , 3 =&gt; [ 4 ] , 4 =&gt; [ 3 ] } iex&gt; Archeometer.Analysis.DSM . gen_dsm ( adj_list ) % Archeometer.Analysis.DSM { edges : %{ { 1 , 1 } =&gt; :+ , { 2 , 1 } =&gt; :* , { 2 , 2 } =&gt; :+ , { 3 , 1 } =&gt; :* , { 3 , 2 } =&gt; :* , { 3 , 3 } =&gt; :+ , { 3 , 4 } =&gt; :* , { 4 , 2 } =&gt; :* , { 4 , 3 } =&gt; :* , { 4 , 4 } =&gt; :+ } , groups : %{ } , n_groups : 0 , nodes : [ 1 , 2 , 3 , 4 ] }","ref":"Archeometer.Analysis.DSM.html#gen_dsm/1","title":"Archeometer.Analysis.DSM.gen_dsm/1","type":"function"},{"doc":"Generates a DSM using module xref information from an Archeometer DB. Parameters app is an application name, in the case of an umbrella project, it's the name of one of the child applications. namespace is a &quot;namespace&quot; to narrow the set of modules considered for createing the DSM. The term &quot;namespace&quot; is meant very broadly since Elixir doesn't have that concept. Namespace can be interpreted as a string matching the beginning of the module names to be considered, such as &quot;Foo&quot; or &quot;Foo.Bar&quot;, after which a last part of the name must be given to create a full module name. For example the &quot;namespace&quot; Foo will include in the analysis modules such as Foo.Bar and Foo.Baz but not FooBar or Food . db_name is the name of the database file to be used. skip_tests is a boolean indicating if test related modules should be skipped. Examples Using Archeometer provided test database. iex&gt; Archeometer.Analysis.DSM . gen_dsm ( ...&gt; &quot;jissai&quot; , ...&gt; &quot;Jissai.Reports&quot; , ...&gt; &quot;./test/resources/db/archeometer_jissai.db&quot; , ...&gt; true ...&gt; ) { :ok , % Archeometer.Analysis.DSM { edges : %{ { 21 , 21 } =&gt; :+ , { 22 , 21 } =&gt; :* , { 22 , 22 } =&gt; :+ , { 23 , 21 } =&gt; :* , { 23 , 23 } =&gt; :+ , { 24 , 21 } =&gt; :* , { 24 , 24 } =&gt; :+ } , groups : %{ } , n_groups : 0 , nodes : [ 21 , 22 , 23 , 24 ] } , %{ 21 =&gt; &quot;Jissai.Reports&quot; , 22 =&gt; &quot;Jissai.Reports.Attendance&quot; , 23 =&gt; &quot;Jissai.Reports.ClassDynamic&quot; , 24 =&gt; &quot;Jissai.Reports.Participant&quot; } }","ref":"Archeometer.Analysis.DSM.html#gen_dsm/4","title":"Archeometer.Analysis.DSM.gen_dsm/4","type":"function"},{"doc":"","ref":"Archeometer.Analysis.DSM.html#group_to_names/2","title":"Archeometer.Analysis.DSM.group_to_names/2","type":"function"},{"doc":"Gets the largest group of modules with cyclical dependencies from a triangularized DSM. If both arguments are maps, then it is assumed they are the DSM and the modules. Otherwise there are treated as the namespace and the database name, and will perfom an extra query to get the DSM and the modules.","ref":"Archeometer.Analysis.DSM.html#largest_cyclic_deps_group/2","title":"Archeometer.Analysis.DSM.largest_cyclic_deps_group/2","type":"function"},{"doc":"Finds the leave nodes in a DSM. Leave nodes are the ones that no dependencies upon other nodes.","ref":"Archeometer.Analysis.DSM.html#leaves/1","title":"Archeometer.Analysis.DSM.leaves/1","type":"function"},{"doc":"Finds the root nodes in a DSM. Root nodes are the ones that no othe node has dependencies upon.","ref":"Archeometer.Analysis.DSM.html#roots/1","title":"Archeometer.Analysis.DSM.roots/1","type":"function"},{"doc":"Reorders a DSM to find dependency cycles. The cycles are identified in the groups attribute of the resulting DSM. Examples A DSM with one cycle iex&gt; dsm = % Archeometer.Analysis.DSM { ...&gt; edges : %{ ...&gt; { 1 , 1 } =&gt; :+ , ...&gt; { 2 , 1 } =&gt; :* , ...&gt; { 2 , 2 } =&gt; :+ , ...&gt; { 3 , 1 } =&gt; :* , ...&gt; { 3 , 2 } =&gt; :* , ...&gt; { 3 , 3 } =&gt; :+ , ...&gt; { 3 , 4 } =&gt; :* , ...&gt; { 4 , 2 } =&gt; :* , ...&gt; { 4 , 3 } =&gt; :* , ...&gt; { 4 , 4 } =&gt; :+ ...&gt; } , ...&gt; groups : %{ } , ...&gt; n_groups : 0 , ...&gt; nodes : [ 1 , 2 , 3 , 4 ] ...&gt; } iex&gt; Archeometer.Analysis.DSM . triangularize ( dsm ) % Archeometer.Analysis.DSM { edges : %{ { 1 , 1 } =&gt; :+ , { 2 , 1 } =&gt; :* , { 2 , 2 } =&gt; :+ , { 3 , 1 } =&gt; :* , { 3 , 2 } =&gt; :* , { 3 , 3 } =&gt; :+ , { 3 , 4 } =&gt; :* , { 4 , 2 } =&gt; :* , { 4 , 3 } =&gt; :* , { 4 , 4 } =&gt; :+ } , groups : %{ &quot;g1&quot; =&gt; [ 3 , 4 ] } , n_groups : 1 , nodes : [ 1 , 2 , 3 , 4 ] } As you can see, it detected the only existing cycle, formed by nodes [3, 4] . The nodes of the DSM are reordered such that the only nodes above the diagonal, are the ones forming part of a cycle. Now a DSM with two cycles iex&gt; dsm = % Archeometer.Analysis.DSM { ...&gt; edges : %{ ...&gt; { 1 , 1 } =&gt; :+ , ...&gt; { 2 , 1 } =&gt; :* , ...&gt; { 2 , 2 } =&gt; :+ , ...&gt; { 2 , 3 } =&gt; :* , ...&gt; { 3 , 1 } =&gt; :* , ...&gt; { 3 , 2 } =&gt; :* , ...&gt; { 3 , 3 } =&gt; :+ , ...&gt; { 4 , 4 } =&gt; :+ , ...&gt; { 4 , 5 } =&gt; :* , ...&gt; { 5 , 4 } =&gt; :* , ...&gt; { 5 , 5 } =&gt; :+ ...&gt; } , ...&gt; groups : %{ } , ...&gt; n_groups : 0 , ...&gt; nodes : [ 1 , 2 , 3 , 4 , 5 ] ...&gt; } iex&gt; Archeometer.Analysis.DSM . triangularize ( dsm ) % Archeometer.Analysis.DSM { edges : %{ { 1 , 1 } =&gt; :+ , { 2 , 1 } =&gt; :* , { 2 , 2 } =&gt; :+ , { 2 , 3 } =&gt; :* , { 3 , 1 } =&gt; :* , { 3 , 2 } =&gt; :* , { 3 , 3 } =&gt; :+ , { 4 , 4 } =&gt; :+ , { 4 , 5 } =&gt; :* , { 5 , 4 } =&gt; :* , { 5 , 5 } =&gt; :+ } , groups : %{ &quot;g1&quot; =&gt; [ 2 , 3 ] , &quot;g2&quot; =&gt; [ 4 , 5 ] } , n_groups : 2 , nodes : [ 1 , 2 , 3 , 4 , 5 ] } It correctly detects the two cycles: [2, 3] and [4, 5] . Now a DSM with a cycle of 3 nodes iex&gt; dsm = % Archeometer.Analysis.DSM { ...&gt; edges : %{ ...&gt; { 1 , 1 } =&gt; :+ , ...&gt; { 2 , 1 } =&gt; :* , ...&gt; { 2 , 2 } =&gt; :+ , ...&gt; { 2 , 4 } =&gt; :* , ...&gt; { 3 , 2 } =&gt; :* , ...&gt; { 3 , 3 } =&gt; :+ , ...&gt; { 4 , 3 } =&gt; :* , ...&gt; { 4 , 4 } =&gt; :+ ...&gt; } , ...&gt; groups : %{ } , ...&gt; n_groups : 0 , ...&gt; nodes : [ 1 , 2 , 3 , 4 ] ...&gt; } iex&gt; Archeometer.Analysis.DSM . triangularize ( dsm ) % Archeometer.Analysis.DSM { edges : %{ { 1 , 1 } =&gt; :+ , { 2 , 1 } =&gt; :* , { 2 , 2 } =&gt; :+ , { 2 , 4 } =&gt; :* , { 3 , 2 } =&gt; :* , { 3 , 3 } =&gt; :+ , { 4 , 3 } =&gt; :* , { 4 , 4 } =&gt; :+ } , groups : %{ &quot;g1&quot; =&gt; [ 2 , 3 , 4 ] } , n_groups : 1 , nodes : [ 1 , 2 , 3 , 4 ] } The cycle is correctly detected: [2, 3, 4] .","ref":"Archeometer.Analysis.DSM.html#triangularize/1","title":"Archeometer.Analysis.DSM.triangularize/1","type":"function"},{"doc":"Functions for generating different TreeMaps.","ref":"Archeometer.Analysis.Treemap.html","title":"Archeometer.Analysis.Treemap","type":"module"},{"doc":"","ref":"Archeometer.Analysis.Treemap.html#add_groups/3","title":"Archeometer.Analysis.Treemap.add_groups/3","type":"function"},{"doc":"","ref":"Archeometer.Analysis.Treemap.html#add_modules/3","title":"Archeometer.Analysis.Treemap.add_modules/3","type":"function"},{"doc":"","ref":"Archeometer.Analysis.Treemap.html#parents/2","title":"Archeometer.Analysis.Treemap.parents/2","type":"function"},{"doc":"Generates a treemap with the given options. Available metrics: size: functions: issues: Available options: app: Application where the modules to consider belong (default: :none, it means to include all applications) namespace: Namespace of the desired modules (default: &quot;*&quot;) db: Path to Database (default: archeometer_project_name.db) skip_tests: If skip testing modules or not (default: true) Examples iex&gt; treemap(:size, ...&gt; app: &quot;jissai&quot;, ...&gt; namespace: &quot;Jissai.Reports.Attendance&quot;, ...&gt; db: &quot;test/resources/db/archeometer_jissai.db&quot; ...&gt; ) %Archeometer.Analysis.Treemap.Node{ kind: :group, metric: :size, name: &quot;Jissai&quot;, nodes: [ % Archeometer.Analysis.Treemap.Node { kind : :group , name : &quot;Jissai.Reports&quot; , nodes : [ % Archeometer.Analysis.Treemap.Node { kind : :leaf , name : &quot;Jissai.Reports.Attendance&quot; , nodes : [ ] , pct : 100.0 , val : 21 } ] , pct : 100.0 , val : 21 } ], pct: 100, val: 21 } Then it can be rendered as SVG with Treemap.SVGRender.render/1","ref":"Archeometer.Analysis.Treemap.html#treemap/2","title":"Archeometer.Analysis.Treemap.treemap/2","type":"function"},{"doc":"Represents a Node within a Treemap.","ref":"Archeometer.Analysis.Treemap.Node.html","title":"Archeometer.Analysis.Treemap.Node","type":"module"},{"doc":"This module provides functions to calculate coordinates and size from Archeometer.Analysis.Treemap.Node to be rendered by Archeometer.Analysis.Treemap.SVGrender .","ref":"Archeometer.Analysis.Treemap.Rectangle.html","title":"Archeometer.Analysis.Treemap.Rectangle","type":"module"},{"doc":"","ref":"Archeometer.Analysis.Treemap.Rectangle.html#create_rectangle/2","title":"Archeometer.Analysis.Treemap.Rectangle.create_rectangle/2","type":"function"},{"doc":"","ref":"Archeometer.Analysis.Treemap.Rectangle.html#layout_row/3","title":"Archeometer.Analysis.Treemap.Rectangle.layout_row/3","type":"function"},{"doc":"","ref":"Archeometer.Analysis.Treemap.Rectangle.html#row_orientation/1","title":"Archeometer.Analysis.Treemap.Rectangle.row_orientation/1","type":"function"},{"doc":"","ref":"Archeometer.Analysis.Treemap.Rectangle.html#shortest_drawable_side/1","title":"Archeometer.Analysis.Treemap.Rectangle.shortest_drawable_side/1","type":"function"},{"doc":"Struct that contains starting coordinates, size and other data for an area that will be rendered by Archeometer.Analysis.Treemap.SVGRender.","ref":"Archeometer.Analysis.Treemap.Rectangle.Area.html","title":"Archeometer.Analysis.Treemap.Rectangle.Area","type":"module"},{"doc":"Functions to render an Archeometer.Analysis.Treemap struct into a svg image. Squarified algorithm by Mark Bruls, Kees Huizing, and Jarke J. van Wijk: https://www.win.tue.nl/~vanwijk/stm.pdf","ref":"Archeometer.Analysis.Treemap.SVGRender.html","title":"Archeometer.Analysis.Treemap.SVGRender","type":"module"},{"doc":"Renders a Treemap struct into a svg . Returns the string representing the generated svg image. The resulting svg can be written to a file or directly embedded into an HTML . Parameters root_node . The Treemap struct with pct: 100 value to be rendered.","ref":"Archeometer.Analysis.Treemap.SVGRender.html#render/2","title":"Archeometer.Analysis.Treemap.SVGRender.render/2","type":"function"},{"doc":"Functions for generating a dependency graph from a list of given modules. Accepted output formats are &quot;dot&quot; (graphviz), &quot;png&quot; and &quot;mermaid&quot;.","ref":"Archeometer.Analysis.Xref.html","title":"Archeometer.Analysis.Xref","type":"module"},{"doc":"","ref":"Archeometer.Analysis.Xref.html#gen_graph/3","title":"Archeometer.Analysis.Xref.gen_graph/3","type":"function"},{"doc":"Creates a dependency graph between the modules given as parameters Parameters modules is either a list of module names, e.g. [Foo.Bar, Foo.Rex, Foo.Zorg] or a tuple {application, namespace} where application is the name of a specific applciation or :none for all applications, and namespace is a specific namespace or &quot;*&quot; . format can be one of &quot;dot&quot; (graphviz), &quot;png&quot;, or &quot;mermaid&quot;. db_name is the filename of the DB to be used. If not given uses default DB. Returns The binary representing the graph, if the operation was completed successfully. {:error, reason} if not.","ref":"Archeometer.Analysis.Xref.html#graph/1","title":"Archeometer.Analysis.Xref.graph/1","type":"function"},{"doc":"Takes a map representing the adjacency list of a graph, and renders it using the appropriante backend. This can be both plain text graph formats (mermaid or dot) or image formats (svg or png). iex&gt; render ( %{ &quot;a&quot; =&gt; [ &quot;b&quot; ] , &quot;b&quot; =&gt; [ ] } , &quot;dot&quot; ) =~ ...&gt; ~r/digraph G { \\n .* \\n .* \\n &quot;a&quot; .*; \\n &quot;b&quot; .*; \\n &quot;a&quot; -&gt; &quot;b&quot;; \\n } \\n / true iex&gt; render ( %{ &quot;a&quot; =&gt; [ &quot;b&quot; ] , &quot;b&quot; =&gt; [ ] } , &quot;mermaid&quot; ) ~s/graph TD; \\n id_0([a]); \\n id_1([b]); \\n id_0--&gt;id_1; \\n /","ref":"Archeometer.Analysis.Xref.html#render/2","title":"Archeometer.Analysis.Xref.render/2","type":"function"},{"doc":"","ref":"Archeometer.Analysis.Xref.html#xrefs/2","title":"Archeometer.Analysis.Xref.xrefs/2","type":"function"},{"doc":"Functions to render an Archeometer.Analysis.DSM struct into plain text.","ref":"Archeometer.Analysis.DSM.ConsoleRender.html","title":"Archeometer.Analysis.DSM.ConsoleRender","type":"module"},{"doc":"","ref":"Archeometer.Analysis.DSM.ConsoleRender.html#cycles_str/2","title":"Archeometer.Analysis.DSM.ConsoleRender.cycles_str/2","type":"function"},{"doc":"","ref":"Archeometer.Analysis.DSM.ConsoleRender.html#ln_sep/0","title":"Archeometer.Analysis.DSM.ConsoleRender.ln_sep/0","type":"function"},{"doc":"","ref":"Archeometer.Analysis.DSM.ConsoleRender.html#mtx_header/2","title":"Archeometer.Analysis.DSM.ConsoleRender.mtx_header/2","type":"function"},{"doc":"","ref":"Archeometer.Analysis.DSM.ConsoleRender.html#mtx_rows/2","title":"Archeometer.Analysis.DSM.ConsoleRender.mtx_rows/2","type":"function"},{"doc":"","ref":"Archeometer.Analysis.DSM.ConsoleRender.html#mtx_str/1","title":"Archeometer.Analysis.DSM.ConsoleRender.mtx_str/1","type":"function"},{"doc":"","ref":"Archeometer.Analysis.DSM.ConsoleRender.html#padding/1","title":"Archeometer.Analysis.DSM.ConsoleRender.padding/1","type":"function"},{"doc":"Renders a DSM struct into a plain text, suitable for printing in a console. Returns the string representing the DSM in human readable format. Parameters dsm . The DSM to be rendered. mod_names . A map from module ids to their corresponding names.","ref":"Archeometer.Analysis.DSM.ConsoleRender.html#render/2","title":"Archeometer.Analysis.DSM.ConsoleRender.render/2","type":"function"},{"doc":"Functions to render an Archeometer.Analysis.DSM struct into a svg image.","ref":"Archeometer.Analysis.DSM.SVGRender.html","title":"Archeometer.Analysis.DSM.SVGRender","type":"module"},{"doc":"Renders a DSM struct into a svg . Returns the string representing the generated svg image. The resulting svg can be written to a file or directly embedded into an HTML . Parameters dsm . The DSM to be rendered. mod_names . A map from module ids to their corresponding names.","ref":"Archeometer.Analysis.DSM.SVGRender.html#render/2","title":"Archeometer.Analysis.DSM.SVGRender.render/2","type":"function"},{"doc":"Functions to iterate over the DSM matrix to find the coordinates of the modules that have cyclic dependencies.","ref":"Archeometer.Analysis.DSM.Utils.html","title":"Archeometer.Analysis.DSM.Utils","type":"module"},{"doc":"Generates a map where the keys are the matrix coordinates of all dependencies in the DSM, and the values the type of dependency. Parameters dsm the dependency structure matrix. Returns A map with the module coordinates and the type of dependency as a value.","ref":"Archeometer.Analysis.DSM.Utils.html#to_coord_mtx/1","title":"Archeometer.Analysis.DSM.Utils.to_coord_mtx/1","type":"function"},{"doc":"Get coordinates of the modules that have cyclic dependencies. On the matrix, thse are the modules above the diagonal. Parameters dsm the dependency structure matrix. Returns r and c coordinates in the DSM.","ref":"Archeometer.Analysis.DSM.Utils.html#upper_right_group_corners/1","title":"Archeometer.Analysis.DSM.Utils.upper_right_group_corners/1","type":"function"},{"doc":"Functions for working with Graphviz graphs","ref":"Archeometer.Graphs.Graphviz.html","title":"Archeometer.Graphs.Graphviz","type":"module"},{"doc":"Renders an graph represented by an adjacency list into .dot format. Returns a string containing de rendered graph. Examples iex(2)&gt; graph = %{ ...(2)&gt; :a =&gt; [ :b , :c ] , ...(2)&gt; :b =&gt; [ :c , :d ] , ...(2)&gt; :d =&gt; [ :a ] ...(2)&gt; } %{ a : [ :b , :c ] , b : [ :c , :d ] , d : [ :a ] } iex(3)&gt; dot_str = Graphviz . render_dot ( graph ) iex(3)&gt; assert is_binary ( dot_str )","ref":"Archeometer.Graphs.Graphviz.html#render_dot/2","title":"Archeometer.Graphs.Graphviz.render_dot/2","type":"function"},{"doc":"Renders an graph represented by an adjacency list into .png format. Returns a binary containing the rendered graph.","ref":"Archeometer.Graphs.Graphviz.html#render_image/3","title":"Archeometer.Graphs.Graphviz.render_image/3","type":"function"},{"doc":"Functions for working with mermaid-JS graphs","ref":"Archeometer.Graphs.Mermaid.html","title":"Archeometer.Graphs.Mermaid","type":"module"},{"doc":"Renders an graph represented by an adjacency list into .dot format. Returns a string containing de rendered graph. Examples iex(2)&gt; graph = %{ ...(2)&gt; :a =&gt; [ :b , :c ] , ...(2)&gt; :b =&gt; [ :c , :d ] , ...(2)&gt; :d =&gt; [ :a ] ...(2)&gt; } %{ a : [ :b , :c ] , b : [ :c , :d ] , d : [ :a ] } iex(3)&gt; str = Mermaid . render ( graph ) iex(3)&gt; assert is_binary ( str )","ref":"Archeometer.Graphs.Mermaid.html#render/1","title":"Archeometer.Graphs.Mermaid.render/1","type":"function"},{"doc":"This module exposes a from/2 macro to creates queries for the Archeometer database. The recommended way to use it is to import the whole module. Let's see a simple example! import Archeometer.Query alias Archeometer.Schema.Module # then you can use it to make queries! Archeometer.Repo . all ( from m in Module , select : m . name , where : m . num_lines &gt; 50 ) The first argument must be an expression in the form of m in Module , where m will be the prefix used for all the fields in the query, and Module is a module implementing Archeometer.Schema . The available schemas are Archeometer.Schema.Module Archeometer.Schema.Function Archeometer.Schema.Macro Archeometer.Schema.XRef Archeometer.Schema.App Each schema specifies its fields and how it is related to the other schemas, like in an SQL Database! Query keywords The rest of the arguments specify how to construct the query. Each option is mapped to an SQL keyword. They are :select :where :order_by :group_by :having :limit Each option accepts either an Archeometer.Query.Term expression or an Archeometer.Query.Term.Container container (tuples, lists or maps). For keyword lists and maps, the keys can be used as aliases in the rest of the query. In the case of the order_by , they keys are used to determine the order. import Archeometer.Query alias Archeometer.Schema.Module from m in Module , select : [ app : m . app . name , avg_cc : avg ( m . cc ) ] where : m . app == &quot;archeometer&quot; order_by : [ desc : sum ( m . num_lines ) ] , group_by : m . app . name having : avg_cc &gt; 5 , limit : 10 Fields and tables Only fields can be selected. Trying to select reference to other tables will return an error. For example import Archeometer.Query alias Archeometer.Schema.Module # this will fail because `functions` is a table from m in Module , select : m . functions # this works because `name` is a field from m in Module , select : m . functions . name More Examples like operator with named columns iex&gt; from f in Archeometer.Schema.Function , ...&gt; select : [ name : f . name , arity : f . num_args ] , ...&gt; where : arity &gt; 3 , ...&gt; where : like ( f . module . name , &quot;Kamaji.Web.%&quot; ) Boolean operators iex&gt; from m in Archeometer.Schema.Module , ...&gt; where : like ( m . name , &quot;%&quot; ) &gt; 5 and sum ( m . functions . cc ) &gt; 5 or not m . num_lines &lt; 500 , ...&gt; select : [ m . name , m . app . name ] Grouping with nested aggregation iex&gt; from m in Archeometer.Schema.Module , ...&gt; group_by : m . id , ...&gt; having : max_cc &gt; 5 , ...&gt; select : [ module : m . name , max_cc : max ( m . functions . cc ) ] iex&gt; from m in Archeometer.Schema.Module , ...&gt; group_by : name , ...&gt; select : [ name : m . name , num_deps : count ( m . out_refs . callee . name ) ] iex&gt; from m in Archeometer.Schema.Module , ...&gt; group_by : name , ...&gt; select : [ name : m . name , num_usages : count ( m . in_refs . caller . name ) ] not and is_nil iex&gt; from f in Archeometer.Schema.Function , ...&gt; where : not is_nil ( f . coverage ) , ...&gt; select : [ f . module . name , f . name , f . num_args ] A more complex query iex&gt; from m in Archeometer.Schema.Module , ...&gt; select : [ name : m . name , acc_cc : sum ( m . functions . cc ) ] , ...&gt; group_by : name , ...&gt; where : m . num_lines &gt; 100 and m . coverage &lt; 0.9 , ...&gt; where : not exists ( m . macros . name ) , ...&gt; order_by : [ desc : acc_cc ] , ...&gt; limit : 10","ref":"Archeometer.Query.html","title":"Archeometer.Query","type":"module"},{"doc":"","ref":"Archeometer.Query.html#from/2","title":"Archeometer.Query.from/2","type":"macro"},{"doc":"","ref":"Archeometer.Query.html#initial_query_for/2","title":"Archeometer.Query.initial_query_for/2","type":"function"},{"doc":"","ref":"Archeometer.Query.html#intersection/2","title":"Archeometer.Query.intersection/2","type":"function"},{"doc":"","ref":"Archeometer.Query.html#root_prefix/1","title":"Archeometer.Query.root_prefix/1","type":"function"},{"doc":"This module represents SQL subqueries. This subqueries partially mimics a query. At the moment, only a select field is allowed.","ref":"Archeometer.Query.Subquery.html","title":"Archeometer.Query.Subquery","type":"module"},{"doc":"Currently, the only way to use sub queries is through an SQL keyword with support for them. Of course, initially those keywords have regular ASTs as arguments. Here, we replace the AST of the arguments of those keywords with subqueries.","ref":"Archeometer.Query.Subquery.html#escape_subqueries/2","title":"Archeometer.Query.Subquery.escape_subqueries/2","type":"function"},{"doc":"Creates a new subquery from with the given query as parent.","ref":"Archeometer.Query.Subquery.html#new/2","title":"Archeometer.Query.Subquery.new/2","type":"function"},{"doc":"Restrict and adapt Elixir terms to a subset that is translatable to SQLite expressions. See the language reference The following literals are allowed Integers Floating point numbers Bitstrings Booleans Lists Plus some operators and functions Boolean operators: and , or , not Comparaison operators: == , != , &lt; , &gt; , &lt;= , &gt;= Arithmetic operators: + , - , * , / Arithmetic functions: round Search functions: like Null checking: is_nil , not is_nil Aggregation functions: avg , count , max , min , sum Subquery expressions: exists in operator And any kind of dot operator: m.some.key.or.attribute to represent table lookup. For example max ( m . num_lines , 10 * m . num_args ) m . cc &gt; 10 like ( m . name , &quot;Archeometer.%&quot; ) and m . name != &quot;Archeometer.Query.Term&quot; Tuples and maps are allowed but only as a top level construct. { m . name , m . num_lines , avg ( m . functions . cc ) } # this is valid [ name , num_lines * 10 ] # this as well { m . name , { m . functions . name , m . functions . num_lines } } # this is not [ m . name , { m . num_lines } ] # neither is this","ref":"Archeometer.Query.Term.html","title":"Archeometer.Query.Term","type":"module"},{"doc":"Takes a validated AST and tries to transformed into its original state. Most of the metadata is long gone by this point, but at least the original structure is preserved.","ref":"Archeometer.Query.Term.html#to_ast/1","title":"Archeometer.Query.Term.to_ast/1","type":"function"},{"doc":"Takes a validated AST and tries to transformed into an SQL-compatible io_data. The goal would be to obtain valid SQL just by calling IO.iodata_to_binary/1 .","ref":"Archeometer.Query.Term.html#to_iodata/1","title":"Archeometer.Query.Term.to_iodata/1","type":"function"},{"doc":"Takes an AST and returns a validated AST.For the most part it is identical to the original, except with anotated symbols.lookups instead of dot operators.","ref":"Archeometer.Query.Term.html#validate/1","title":"Archeometer.Query.Term.validate/1","type":"function"},{"doc":"Utility functions for dealing with &quot;container&quot; AST. That is, tuples, list, keyword list and maps. Some examples of valid containers [ &quot;regular&quot; , &quot;lists&quot; ] [ keyword : &quot;lists&quot; ] { &quot;simple&quot; , &quot;tuples&quot; } %{ map : &quot;values&quot; } The only restriction for containers is that they can't be nested.","ref":"Archeometer.Query.Term.Container.html","title":"Archeometer.Query.Term.Container","type":"module"},{"doc":"Wrapper to work with the AST of container terms (i.e. tuples, maps and lists).","ref":"Archeometer.Query.Term.Container.html#reduce/3","title":"Archeometer.Query.Term.Container.reduce/3","type":"function"},{"doc":"Specify data base table information in Elixir modules. The information must be specified inside a defschema/1 macro. An schema has field properties. Foreign keys are specied with a belongs_to property. And the opposite is spcified with a has property. Example defmodule ModuleA do use Archeometer.Schema defschema do field :first_module , primary_key : true belongs_to ModuleB has ModuleB , as : :other_b , key : :recurse_id end end","ref":"Archeometer.Schema.html","title":"Archeometer.Schema","type":"module"},{"doc":"This property marks a foreign key. This is usually to specify the many entity in a many-to-one relation. Using the name of the reference table, a field will be generated. This generated name will be a queryable field in the schema. The name can be specified with the as: name optional parameter. The name of the foreign key will be inferred from the name of the referenced table. This can be overriden with the key: key_name optional paramenter. For example defmodule B do use Archeometer.Schema defschema :b do field :id , primary_key : true belongs_to A # with inferred name `:a` and key `:a_id` belongs_to A , as : :other_a , key : :other_a_id end end Where A is defined as follows defmodule A do use Archeometer.Schema defschema :schema do field :id , primary_key : true has B # with infererd name `:b` and foreign key `:a_id` has B , as : :other_b , key : other_a end end","ref":"Archeometer.Schema.html#belongs_to/2","title":"Archeometer.Schema.belongs_to/2","type":"macro"},{"doc":"Starts the definition of a new schema. This definition maps database columns into Elixir data. The field , has and belongs_to macros are available to specify how to map the data base table to Elixir terms. See their individual documentation of each for the list of properties they can specify.","ref":"Archeometer.Schema.html#defschema/2","title":"Archeometer.Schema.defschema/2","type":"macro"},{"doc":"Specify that the current schema has fields. The first argument is the name of the field, and as an optional argument you can specify if the current field is a primary key. For example defmodule A do use Archeometer.Schema defschema :a do field :id , primary_key : true field :name end end","ref":"Archeometer.Schema.html#field/2","title":"Archeometer.Schema.field/2","type":"macro"},{"doc":"This property denotes that there is a foreign key in other table that makes reference to the current table. This is usually to specify the one entity in a many-to-one relation. Using the name of the reference table, a field will be generated. This generated name will be a queryable field in the schema. The name can be specified with the as: name optional parameter. The name of the foreign key in the other table will be inferred from the name of the current table. This can be overriden with the key: key_name optional paramenter. For example defmodule A do use Archeometer.Schema defschema :schema do field :id , primary_key : true has B # with infererd name `:b` and foreign key `:a_id` has B , as : :other_b , key : other_a end end Where B is defined as follows defmodule B do use Archeometer.Schema defschema :b do field :id , primary_key : true belongs_to A # with inferred name `:a` and key `:a_id` belongs_to A , as : :other_a , key : :other_a_id end end","ref":"Archeometer.Schema.html#has/2","title":"Archeometer.Schema.has/2","type":"macro"},{"doc":"This modules represents a OTP application. It holds the relevant schema data that will be used in the project analysis. This schema has the following fields: name is the name of the OTP application is_external if the application is external (dependency) modules is a reference to Archeometer.Schema.Modules . All the modules belonging to the application.","ref":"Archeometer.Schema.App.html","title":"Archeometer.Schema.App","type":"module"},{"doc":"Represents an cross reference between applications. The schema has the following fields: caller is a reference to Archeometer.Schema.App . The module were the referece took place. callee is a reference to Archeometer.Schema.App . The module being referenced.","ref":"Archeometer.Schema.AppXRef.html","title":"Archeometer.Schema.AppXRef","type":"module"},{"doc":"Represents an implementation of a Behaviour into a module. This schema has te following fields: name is the name of the implemented behaviour. module is the reference to Archeometer.Schema.Module . It is the module that implements the behaviour.","ref":"Archeometer.Schema.Behaviour.html","title":"Archeometer.Schema.Behaviour","type":"module"},{"doc":"Represents a credo issue found in a module. check_module is the name of the failed check. line_no the line number where the issue was found. severity the is the importance of the failed check. module is a reference to Archeometer.Schema.Module . It is the module were the issue was found","ref":"Archeometer.Schema.CredoIssue.html","title":"Archeometer.Schema.CredoIssue","type":"module"},{"doc":"Represents an Elixir function. Holds the relevant schema data that will be used in the project analysis. This schema has the following fields: name is the name of the function cc represents the cyclomatic complexity. num_lines is the number of lines in the function definition. num_args is the number of arguments the function receives. arg_names is a comma separated list with the name of the parameters the function receives. type can be either def or defp depending on the function declaration. coverage is a number between 0 and 1 representing the percentage of tested lines of code. It is pulled directly from Erlang's code module, so it might not be very accurate. module is a referece to Archeometer.Schema.Module . It is the module where the function was declared.","ref":"Archeometer.Schema.Function.html","title":"Archeometer.Schema.Function","type":"module"},{"doc":"Represents an Elixir macro. Holds the relevant schema data that will be used in the project analysis. This schema has the following fields: name if the name of the macro. cc if the cyclomatic complexity of the macro declaration. num_lines is the length of macro declaration. num_args is the number of arguments the macro receives. arg_names is a comma separated string with the name of the parameters the macro receives. type can be either defmacro or defmacrop , depending on the declaration. coverage is a number between 0 and 1 representing the test coverage of the macro. The results are pulled from Erlang code module so they might not be very accurate. module is a reference to Archeometer.Schema.Module . The module where the macro was declared.","ref":"Archeometer.Schema.Macro.html","title":"Archeometer.Schema.Macro","type":"module"},{"doc":"Represents an Elixir module. Holds the relevant schema data that will be used in the project analysis. This schema has the following fields: name is the name of the module. num_lines is the length of the module delcaration body. coverage is a number between 0 and 1 representing the module testing coverage percentage. path is the file path where the module was declared. has_struct is 1 when the module has a struct and 0 if not. has_ecto_schema is 1 when the module defines an ecto schema and 0 if not. is_test is 1 when the module is a test. app is a reference to Archeometer.Schema.App . It is the module's corresponding OTP application in_refs stands for &quot;incoming references&quot;. That is, all references of the current module in other modules. Or in other words all the usages of the current module. out_refs stands for &quot;outgoing reference&quot;. That is, all references from other modules in the current one. Or said on other words, the current module dependencies. functions is a reference to Archeometer.Schema.Function . All the functions defined in the module. macros is a reference to Archeometer.Schema.Macro . All the macros defined in the module. behaviours is a reference to Archeometer.Schema.Behaviour . Behaviours implemented in the module. credo_issues is a reference to Archeometer.Schema.CredoIssue . Credo issues detected on the module.","ref":"Archeometer.Schema.Module.html","title":"Archeometer.Schema.Module","type":"module"},{"doc":"Represents an cross reference between modules. It contains the relevant schema data that will be used in the project analysis. The schema has the following fields: type is the corresponding to the cross reference. The full list of events is documented on the Code module. line is the line number in the file where the reference was detected. caller is a reference to Archeometer.Schema.Module . The module were the referece took place. callee is a reference to Archeometer.Schema.Module . The module being referenced.","ref":"Archeometer.Schema.XRef.html","title":"Archeometer.Schema.XRef","type":"module"},{"doc":"Common utilities for interacting with the database.","ref":"Archeometer.Repo.html","title":"Archeometer.Repo","type":"module"},{"doc":"Execute the given query and returns a Archeometer.Result structure with all rows. The query can be a raw string to be executed directly with the given bindings. In that case the resulting structure won't have header information. The query can also be a tuple {:ok, %Archeometer.Query{}} . Consecuentyl the result of Archeoemter.Query.from can be piped directly. In this case the bindings field will be ignored, as the bindings are stored on the Query structure.","ref":"Archeometer.Repo.html#all/3","title":"Archeometer.Repo.all/3","type":"function"},{"doc":"","ref":"Archeometer.Repo.html#db_has_tables?/2","title":"Archeometer.Repo.db_has_tables?/2","type":"function"},{"doc":"","ref":"Archeometer.Repo.html#db_ready?/2","title":"Archeometer.Repo.db_ready?/2","type":"function"},{"doc":"","ref":"Archeometer.Repo.html#default_db_name/0","title":"Archeometer.Repo.default_db_name/0","type":"function"},{"doc":"","ref":"Archeometer.Repo.html#execute_raw/3","title":"Archeometer.Repo.execute_raw/3","type":"function"},{"doc":"","ref":"Archeometer.Repo.html#execute_raw_query/3","title":"Archeometer.Repo.execute_raw_query/3","type":"function"},{"doc":"A query result with a nicer API to manipulate the data.","ref":"Archeometer.Repo.Result.html","title":"Archeometer.Repo.Result","type":"module"},{"doc":"Merges two query results into one using a common column to pair the results values. Rows from second result are dumped into first one. Examples iex&gt; result1 = ... &gt; % Archeometer.Repo.Result { ...&gt; headers : [ :id , :name ] , rows : [ [ 1 , &quot;archeometer&quot; ] ] } ...&gt; iex&gt; result2 = ... &gt; % Archeometer.Repo.Result { ...&gt; headers : [ :name , :num_mods ] , rows : [ [ &quot;archeometer&quot; , 120 ] ] } ...&gt; iex&gt; Archeometer.Repo.Result . merge ( result1 , result2 , :name ) % Archeometer.Repo.Result { headers : [ :id , :name , :num_mods ] , rows : [ [ 1 , &quot;archeometer&quot; , 120 ] ] } Trying to merge without a common column iex&gt; result1 = ... &gt; % Archeometer.Repo.Result { ...&gt; headers : [ :id , :is_external ] , rows : [ [ 1 , false ] ] } ...&gt; iex&gt; result2 = ... &gt; % Archeometer.Repo.Result { ...&gt; headers : [ :name , :num_mods ] , rows : [ [ &quot;archeometer&quot; , 120 ] ] } ...&gt; iex&gt; Archeometer.Repo.Result . merge ( result1 , result2 , :name ) { :error , &quot;name is not a common column&quot; }","ref":"Archeometer.Repo.Result.html#merge/4","title":"Archeometer.Repo.Result.merge/4","type":"function"},{"doc":"This module provides several helpers functions to deal with Elixir ASTs. The functions have specific uses in other modules, but are general enough to be useful in other contexts.","ref":"Archeometer.Util.Code.html","title":"Archeometer.Util.Code","type":"module"},{"doc":"Create a new atom by concatenaing two other existing ones.","ref":"Archeometer.Util.Code.html#atom_concat/2","title":"Archeometer.Util.Code.atom_concat/2","type":"function"},{"doc":"Walks the AST and finds all the definitions matching the given atoms, except if they are inside a macro definition, as quoted definitions are not yet instantiated.","ref":"Archeometer.Util.Code.html#collect_defs/2","title":"Archeometer.Util.Code.collect_defs/2","type":"function"},{"doc":"Walks the given AST and stores all the ocurrences of the given atom as an operator.","ref":"Archeometer.Util.Code.html#collect_nodes/2","title":"Archeometer.Util.Code.collect_nodes/2","type":"function"},{"doc":"Get declaration information from the AST of a def -like macro. That is usually the name and arguments, but it dependes on the exact construct. Current ones are def, defp, defmacro, defmacrop, defmodule, defstruct .","ref":"Archeometer.Util.Code.html#get_decl/1","title":"Archeometer.Util.Code.get_decl/1","type":"function"},{"doc":"Get the metadata of the given AST.","ref":"Archeometer.Util.Code.html#get_meta/2","title":"Archeometer.Util.Code.get_meta/2","type":"function"},{"doc":"Get the maximum line number present in the metadata of an AST.","ref":"Archeometer.Util.Code.html#num_lines/1","title":"Archeometer.Util.Code.num_lines/1","type":"function"},{"doc":"Determine the name of the module of some subset of the AST.","ref":"Archeometer.Util.Code.html#resolve_mod_name/2","title":"Archeometer.Util.Code.resolve_mod_name/2","type":"function"},{"doc":"Determine the scope of the ast inside the full_ast .","ref":"Archeometer.Util.Code.html#resolve_scope/2","title":"Archeometer.Util.Code.resolve_scope/2","type":"function"},{"doc":"Given a module name, it will return the underscored version of the last part of the module name.","ref":"Archeometer.Util.Code.html#snakefy/1","title":"Archeometer.Util.Code.snakefy/1","type":"function"},{"doc":"","ref":"tasks.html","title":"Tasks Cheatsheet","type":"extras"},{"doc":"Basic execution Run all data collection stages $ mix arch.collect Include dependencies Run all data collection stages on project and dependencies that match filter(s) $ mix arch.collect --include-deps &quot;phoenix*&quot; No coverage Skip coverage information gathering stage $ mix arch.collect --no-coverage","ref":"tasks.html#data-collection","title":"Tasks Cheatsheet - Data Collection","type":"extras"},{"doc":"To be run, it's necessary you already successfully ran the data collection stages Basic execution Generate default HTML static report $ mix arch.report.html Limit Query Results Limit the number of results of the queries used in the report (e.g. to 10 elements) $ mix arch.report.html --limit 10","ref":"tasks.html#html-report","title":"Tasks Cheatsheet - HTML Report","type":"extras"},{"doc":"Option Default Supported by --format Depends on task apps.xref, dsm, treemap, xref --out console apps.xref, dsm, treemap, xref --app * (All applications) dsm, treemap, xref --ns * (All modules) dsm, treemap, xref --db archeometer_&lt;project name&gt;.db dsm, treemap, xref --skip-tests true dsm, treemap A more complex example using this options. This will generate a DSM from a database that is not the defaultone and consider only modules that belong to foo application in the namespace Foo.Bar and not ignoring the test modules. $ mix arch.dsm \\ --out foo.bar.svg \\ --format svg \\ --app foo \\ --ns Foo.Bar \\ --skip-tests false \\ --db archeometer_wareware.db","ref":"tasks.html#analysis-common-options","title":"Tasks Cheatsheet - Analysis Common Options","type":"extras"},{"doc":"Apps XRef Basic execution Print the dependency graph of applications in console (as text) $ mix arch.apps.xref Format Following formats are supported dot (default) png svg Include dependencies Target project and include dependencies that match the filter(s) This option can be used on non-Umbrella projects $ mix arch.apps.xref --include-deps &quot;phoenix*&quot; XRef Basic execution Generate a dependency graph between given modules and print it to console $ mix arch.xref mod1 mod2 .. modN Format Following formats are supported dot (default) png svg Design Structure Matrix (DSM) Basic Execution Generate a DSM of all non-test modules and print it to console $ mix arch.dsm Format Following formats are supported txt svg Treemap Basic Execution Generate a Treemap of all non-test modules from the project and print it to console $ mix arch.treemap Metric For now only size metric is supported $ mix arch.treemap --metric size","ref":"tasks.html#analysis","title":"Tasks Cheatsheet - Analysis","type":"extras"},{"doc":"Include Dependencies Just as in the main Collect task you can include dependencies (not supported by arch.collect.coverage ) $ mix arch.collect.static --include deps &quot;phoenix*&quot; Collect Static Target project ex files but not dependencies $ mix arch.collect.static Collect XRefs Save information of dependencies between project modules $ mix arch.collect.xrefs Collect Apps Save applications names, modules implemented behaviours and structs from project $ mix arch.collect.apps Collect Ecto Save information of Ecto schema modules and their relationships $ mix arch.collect.ecto Collect Coverage Run project tests files and save coverage information $ mix arch.collect.coverage","ref":"tasks.html#collect-subtasks","title":"Tasks Cheatsheet - Collect Subtasks","type":"extras"},{"doc":"Queries are executed with Archeometer.Repo.all/3 . The easiest way to load the query macros is by importing the Archoemeter.Query module. The predefined schemas are under the Archeometer.Schema.* name. For brevity, all examples assume you have an alias to those schemas. import Archeometer.Query alias Archeometer.Schema.Module Archeometer.Repo . all ( from m in Module , where : m . num_lines &gt; 50 , select : [ m . name , m . app . name ] )","ref":"cql.html","title":"CQL Cheatsheet","type":"extras"},{"doc":"Available Keywords :select :where :order_by :group_by :having :limit Select Select all modules name from m in Module , select : [ app : m . name ] Select all applications and the average number of lines per module from m in Module , select : [ app : m . app . name , avg_size : avg ( m . num_lines ) ] Where Select all modules that belongs to Archeometer app from m in Module , select : [ m . name ] , where : m . app . name == &quot;archeometer&quot; Order By Select all modules from project ordered by coverage (ascending) from m in Module , select : [ m . name ] , order_by : m . coverage Select all modules from project ordered by coverage (descending) from m in Module , select : [ m . name ] , order_by : [ desc : m . coverage ] Group By Select functions name, coverage, and module name where coverage is less than 70% and grouped by module name from f in Function , select : [ f . name , f . coverage , f . module . name ] , where : f . coverage &lt; 0.7 , group_by : f . module . name Having Select module name and average functions cyclomatic complexity and selects only modules with an average cyclomatic complexity greater than 2 from f in Function , select : [ module : f . module . name , avg_cc : avg ( f . cc ) ] , group_by : f . module . name , having : avg_cc &gt; 2 Limit Select the 10 functions with the highest cyclomatic complexity from f in Function , select : [ f . name , f . cc ] , order_by : [ desc : f . cc ] , limit : 10","ref":"cql.html#cql-keywords","title":"CQL Cheatsheet - CQL Keywords","type":"extras"},{"doc":"Available Schemas Archeometer.Schema.Module Archeometer.Schema.Function Archeometer.Schema.Macro Archeometer.Schema.XRef Archeometer.Schema.App","ref":"cql.html#cql-schemas","title":"CQL Cheatsheet - CQL Schemas","type":"extras"},{"doc":"Available Literals Integers Floating point numbers Bitstrings Booleans Lists Available Functions Aggregation functions: avg, count, max, min, sum Search functions: like Arithmetic functions: round Subquery expressions: exists Available Operators Boolean operators: and, or, not Comparison operators: ==, !=, &lt;, &gt;, &lt;=, &gt;= Arithmetic operators: +, -, *, / Null checking: is_nil, not is_nil in operator Available Term Containers Tuples Lists Keyword lists Maps Containers can not be nested Boolean Operator Select all modules name that are not defining an Ecto schema from m in Module , select : [ module : m . name ] , where : not m . has_ecto_schema Select all modules name that are a defining an Ecto schema or are defining a struct from m in Module , select : [ module : m . name ] , where : m . has_ecto_schema or m . has_struct Comparison Operators Select modules that are used by other modules at least once from m in Module , select : [ name : m . name , num_usages : count ( m . in_refs . caller . name ) ] , having : num_usages &gt; 0 , group_by : m . name Arithmetic Operators Select all modules and the average cyclomatic complexity of their functions from m in Module , select : [ name : m . name , average_cc : round ( sum ( m . functions . cc ) / count ( m . functions . name ) , 2 ) ] , group_by : m . name Aritmetic Functions Select the 10 modules with the highest number of uncovered lines from m in Module , select : [ name : m . name , uncovered_lines : round ( m . num_lines * ( 1 - m . coverage ) , 0 ) ] , order_by : [ desc : uncovered_lines ] , limit : 10 ) Search Functions Select functions from modules that are in the namespace 'WarewareWeb' from f in Function , select : [ name : f . name , arity : f . num_args ] , where : like ( f . module . name , &quot;WarewareWeb.%&quot; ) Null Checking Select functions name, module name and arity where the function coverage is not nil from f in Function , select : [ f . module . name , f . name , f . num_args ] , where : not is_nil ( f . coverage ) Aggregation Functions Select all modules name and their respective number of usages in other modules from m in Module , select : [ name : m . name , num_usages : count ( m . in_refs . caller . name ) ] , group_by : name Select the modules with a function with cyclomatic complexity greater than 5 from m in Module , select : [ module : m . name , max_cc : max ( m . functions . cc ) ] , group_by : m . id , having : max_cc &gt; 5 Subquery Select all modules that define macros from m in Module , select : m . name , where : exists ( m . macros . name ) IN Operator Select modules that are implementing OTP behaviours from b in Behaviour , select : b . module . name , where : b . name in [ &quot;Application&quot; , &quot;Agent&quot; , &quot;GenServer&quot; , &quot;GenEvent&quot; , &quot;Supervisor&quot; ]","ref":"cql.html#cql-terms","title":"CQL Cheatsheet - CQL Terms","type":"extras"},{"doc":"Archeometer is a tool to collect as much information about your project as possible, and make it available for you to discover the hidden structure and patterns of your projects. Information like: Number of modules, functions and macros per application Local dependencies by type: function calls, macro calls, structure calls Test coverage per module and function Function and macro visibility, length in code lines, cyclomatic complexity Among other information. This is made available through a generated report in HTML and through an Elixir API for you to build your own diagnostics. The goal is to give you an insight into how a project is organized and how it could be improved. To get started visit Installation Basic Usage","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"This is a Mix package, so you must install it using Mix (Available in Hex ). To use it you can add it in your project mix.exs : def deps do [ { :archeometer , &quot;~&gt; 0.2&quot; , only : [ :dev , :test ] , runtime : false } , ] end Or alternatively, you can clone this repository and add the dependency as a path: &quot;path/to/the/repo&quot; instead. And then just run mix deps.get","ref":"installation.html","title":"Installation","type":"extras"},{"doc":"Since this is a tool about project discovery, first we have to collect all the data.","ref":"basic_usage.html","title":"Basic Usage","type":"extras"},{"doc":"To collect all the data simply run mix arch.collect This will run all sorts of different analysis and store all the data in a archeometer_&lt;your_project&gt;.db file. You can skip running tests (for example, it tests take too long to run or they are broken) and collecting coverage information with the --no-coverage flag. mix arch.collect --no-coverage","ref":"basic_usage.html#collect-the-data","title":"Basic Usage - Collect the data","type":"extras"},{"doc":"Under the hood, data collection is divided in several phases. You can run each phase individually. They are arch.collect.static : Analysis the AST of the project code. It requires Credo . arch.collect.xrefs : Collects information about module dependencies. It forces a compilation. arch.collect.apps : Get information about the applications in the project. It must compile the project. arch.collect.ecto : Collects modules with Ecto schema and their associations. arch.collect.credo_issues : to run Credo and collect the issues it found. arch.collect.coverage : Calculate test coverage per module and function. It must run the test suite. Depending on your project, you can choose to run only the stages you are interested in, or to skip some stage that is specially expensive to run. The only necessary stage is arch.collect.static and it must be run before any other.","ref":"basic_usage.html#data-collection-stages","title":"Basic Usage - Data collection stages","type":"extras"},{"doc":"Some collect tasks can also gather information from dependencies, they are static apps ecto xrefs To filter the dependencies you can use the flag --include-deps and a unix-style glob pattern. The credo_issues tasks also accepts the flag but currently ignores it. Pattern mechanisms: * matches none or many tokens ? matches exactly one token [abc] matches a set of tokens [a-z] matches a range of tokens [!...] matches anything but a set of tokens Example mix arch.collect.static --include-deps &#39;phoenix*&#39; This will target: :phoenix :phoenix_ecto :phoenix_gon :phoenix_html :phoenix_live_dashboard :phoenix_live_reload :phoenix_live_view :phoenix_pubsub :phoenix_view ... The flag --include-deps can be passed more than once, the dependencies set will be the union of all the filters, example. mix arch.collect.static --include-deps &#39;ecto*&#39; --include-deps &#39;archeometer&#39; This will target: :archeometer :ecto_sql :ecto","ref":"basic_usage.html#include-dependencies-in-the-analysis","title":"Basic Usage - Include dependencies in the analysis","type":"extras"},{"doc":"There are some predefined tasks to give you a brief overview of the project. mix arch.xref : Will create a dependency graph in several possible formats. mix arch.dsm : Will create a Design Structure Matrix, and will use it to find the cyclic dependencies in the project. mix arch.treemap : Will generate a treemap of the modules within an specific application. mix arch.report.html : Creates a comprehensive report on the project under review.","ref":"basic_usage.html#creating-reports","title":"Basic Usage - Creating reports","type":"extras"},{"doc":"If you want to have a more in depth exploration of your project, don't forget to read the following guides: Queries and Schemas : make queries to the data base using Elixir code","ref":"basic_usage.html#further-reading","title":"Basic Usage - Further reading","type":"extras"},{"doc":"Archeometer.Query defines an Ecto -like query language to get information out of the generated data base without going out of Elixir. For example, to get the top 10 biggest modules, you can use the following import Archeometer.Query alias Archeometer.Schema.Module query = from m in Module , select : [ m . name , m . num_lines ] order_by : [ desc : m . num_lines ] Archeometer.Repo . all ( query ) Let's break it down into simpler parts","ref":"queries_and_schemas.html","title":"Queries and Schema","type":"extras"},{"doc":"You must query an schema. An schema holds the information about the table. It has fields and references to other schemas. In the previous example we used the Archeometer.Schema.Module schema. It looks like this (with some skipped sections for brevity) defschema ( :modules ) do field ( :id , primary_key : true ) field ( :name ) field ( :num_lines ) ... belongs_to ( App , key : :app_id ) has ( Function , as : :functions ) ... end It has the name and num_lines fields, so you can select them. There are references to other schema. They allow you to select fields in other tables. For example the schema at Archeometer.Schema.App looks like this defschema :apps do field ( :id , primary_key : true ) field ( :name ) has ( Module , as : :modules , key : :app_id ) end And the schema at Archeometer.Schema.Function also has a name field. So you can do the following import Archeometer.Query alias Archeometer.Schema.Module from m in Module , select : m . name , m . app . name , m . functions . name And this will select all the function names, with module and application. You can read the Archeometer.Schema documentation for more details about how they work. The available schemas are Archeometer.Schema.Module Archeometer.Schema.Function Archeometer.Schema.Macro Archeometer.Schema.XRef Archeometer.Schema.App","ref":"queries_and_schemas.html#schema","title":"Queries and Schema - Schema","type":"extras"},{"doc":"The expression that are accepted in the queries are a subset of the regular Elixir terms. A subset that is translatable to SQL. For example, in the following query from m in Module , where : m . num_lines &gt; 50 , select : [ m . name , m . app . name ] we use an arithmetic comparison, some integer literals. m.name is a field lookup, m.app.name is also a field lookup, but with an implicit join with another table holding the application information. You can find read more about them in Archoemeter.Query and the whole specification is available in Archeometer.Query.Term .","ref":"queries_and_schemas.html#term-in-query-expressions","title":"Queries and Schema - Term in query expressions","type":"extras"},{"doc":"Queries are built using the Archoemeter.Query.from/2 macro. The first parameter must be a module implementing a schema. The rest are keyword arguments. Each keyword corresponds to an SQL keyword. They more or less replicate the Ecto API. For example you can do the following import Archeometer.Query alias Archeometer.Schema.Module from m in Module , select : [ app : m . app . name , avg_size : avg ( m . num_lines ) ] where : m . app . name == &quot;archeometer&quot; order_by : [ desc : sum ( m . num_lines ) ] , group_by : m . app . name having : avg_size &gt; 50 , limit : 10 To then get all the data you must execute the query. For now the only way to do it is with the Archeometer.Repo.all/1 function, as in the initial example. You can see its full documentation at Archeometer.Repo .","ref":"queries_and_schemas.html#building-queries","title":"Queries and Schema - Building queries","type":"extras"}]